/** Knoten fr die Reprsentation von mathematischen
 * ausdrcken. 
 * Die Knoten werden vom Anwender zu Bumen gebaut.
 */
class MathAusdrKnoten
{
  // Felder
  /** Das linke Kind */
  private MathAusdrKnoten _links = null;
  /** Das rechte Kind */
  private MathAusdrKnoten _rechts = null;
  
  /** Inhalt des Knoten */
  private String _zeichen = null;
  
  
  // Konstruktor
  /** Konstruktor
   * Erzeugt einen Knoten mit zeichen als Zeichen.
   * @param zeichen Das darzustellende Zeichen.
   */
  public MathAusdrKnoten(String zeichen) {
    _zeichen = zeichen;
  }
  
  
  // Zugriff auf die Felder
 /** Gibt das linke Kind zurck */
  public MathAusdrKnoten links() { return _links; }
  
  /** Setzt das linke Kind.
   * @param links Der Knoten der zum linken Kind wird.
   */
  public void setLinks(MathAusdrKnoten links) {
    _links = links;
  }
  
  /** Gibt das rechte Kind zurck */
  public MathAusdrKnoten rechts() { return _rechts; }
  
  /** Setzt das rechte Kind.
   * @param links Der Knoten der zum rechten Kind wird.
   */
  public void setRechts(MathAusdrKnoten rechts) {
    _rechts = rechts;
  }
  
  
  // Traversierungen
  /** Gibt den Teilbaum, der diesen Knoten als Wurzel hat,
   * in der In-Order Reihenfolge auf die Konsole aus.
   */
  public void printInorder() {
    System.out.print("(");
    if(_links != null) { _links.printInorder(); }
    System.out.print(_zeichen);
    if(_rechts != null) { _rechts.printInorder(); }
    System.out.print(")");
  }
  
  /** Gibt den Teilbaum, der diesen Knoten als Wurzel hat,
   * in der Pre-Order Reihenfolge auf die Konsole aus.
   */
  public void printPreorder() {
    System.out.print(_zeichen + " ");
    if(_links != null) { _links.printPreorder(); }
    if(_rechts != null) { _rechts.printPreorder(); }
  }
  
  /** Gibt den Teilbaum, der diesen Knoten als Wurzel hat,
   * in der Post-Order Reihenfolge auf die Konsole aus.
   */
  public void printPostorder() {
    if(_links != null) { _links.printPostorder(); }
    if(_rechts != null) { _rechts.printPostorder(); }
    System.out.print(_zeichen + " ");
  }
  
  /** Berechnet den mathematischen Ausdruck
   * Um die Struktur einfach zuhalten werden nur die 4
   * Grundoperatoren +, -, *, / untersttzt.
   * Sind andere Operatoren im Baum oder ist der Baum nicht
   * korrekt ist das Verhalten unbestimmt.
   */
  public int auswerten() {
    // hat der Knoten Kinder, so handelt es sich um Operatoren
      if (_zeichen.equals("+")) {
        return _links.auswerten() + _rechts.auswerten();
      }
      if (_zeichen.equals("-")) {
        return _links.auswerten() - _rechts.auswerten();
      }
      if (_zeichen.equals("*")) {
        return _links.auswerten() * _rechts.auswerten();
      }
      if (_zeichen.equals("/")) {
        return _links.auswerten() / _rechts.auswerten();
      }
      return Integer.parseInt(_zeichen);
    
  }
}